#include "stdafx.h"

HDC hScreenDC, hMemoryDC;
HBITMAP hBM;
HBITMAP hDefaultBitmap;

BYTE *g_pBits;

int g_swidth, g_sheight;
int g_scanline;

BOOL g_bIsActive = FALSE;

BOOL SetupSoftware(HWND hWnd);
BOOL CloseSoftware(HWND hWnd);

void UpdateFrame();

HBITMAP MakeDIBSection(HDC hDC, int width, int height, BYTE **pBits);


BOOL SetupSoftware(HWND hWnd)
{
	hScreenDC = GetDC(hWnd);
	hMemoryDC = CreateCompatibleDC(hScreenDC);
	hBM = MakeDIBSection(hScreenDC, 800, 600, &g_pBits);
	hDefaultBitmap = (HBITMAP)SelectObject(hMemoryDC, hBM);

	InitTimer();

	g_bIsActive = TRUE;

	return TRUE;
}

BOOL CloseSoftware(HWND hWnd)
{
	SelectObject(hMemoryDC, hDefaultBitmap);
	DeleteDC(hMemoryDC);
	DeleteObject(hDefaultBitmap);
	DeleteObject(hBM);
	ReleaseDC(hWnd, hScreenDC);
		
	return TRUE;
}

void UpdateFrame()
{
	char szText[128];

	FrameCheck();

//	PutPixel(320, 240, 255, 0, 0);
	
	sprintf(szText, "FPS : %f", g_fFPS);
	TextOut(hMemoryDC, 0, 0, szText, strlen(szText));

	BitBlt(hScreenDC, 0, 0, 800, 600, hMemoryDC, 0, 0, SRCCOPY);
}

HBITMAP MakeDIBSection(HDC hDC, int width, int height, BYTE **pBits)
{
	HBITMAP hDIBitmap;
	BITMAPINFO BMInfo;

	BMInfo.bmiHeader.biSize				= sizeof (BITMAPINFOHEADER);
	BMInfo.bmiHeader.biWidth			= width;
	BMInfo.bmiHeader.biHeight			= -height;
	BMInfo.bmiHeader.biPlanes			= 1;
	BMInfo.bmiHeader.biBitCount			= 24;
	BMInfo.bmiHeader.biCompression		= BI_RGB;
	BMInfo.bmiHeader.biSizeImage		= 0;
	BMInfo.bmiHeader.biXPelsPerMeter	= 0;
	BMInfo.bmiHeader.biYPelsPerMeter	= 0;
	BMInfo.bmiHeader.biClrUsed			= 0;
	BMInfo.bmiHeader.biClrImportant		= 0;

	hDIBitmap = CreateDIBSection (hDC, (BITMAPINFO *)&BMInfo, DIB_RGB_COLORS, (VOID **)pBits, NULL, 0);

	g_scanline = (width * 3 + 3)/4 * 4;
	g_swidth = width;
	g_sheight = height;
	
	return (hDIBitmap);
}

